package org.dromara.elevator.service.impl;

import cn.hutool.core.collection.CollUtil;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EElevatorRelevancyDevice;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EElevatorUserBo;
import org.dromara.elevator.domain.vo.EElevatorUserVo;
import org.dromara.elevator.domain.EElevatorUser;
import org.dromara.elevator.mapper.EElevatorUserMapper;
import org.dromara.elevator.service.IEElevatorUserService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 电梯及工作人员关联信息Service业务层处理
 *
 * @author zy
 * @date 2024-09-04
 */
@RequiredArgsConstructor
@Service
public class EElevatorUserServiceImpl implements IEElevatorUserService {

    private final EElevatorUserMapper baseMapper;

    /**
     * 查询电梯及工作人员关联信息
     *
     * @param id 主键
     * @return 电梯及工作人员关联信息
     */
    @Override
    public EElevatorUserVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询电梯及工作人员关联信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 电梯及工作人员关联信息分页列表
     */
    @Override
    public TableDataInfo<EElevatorUserVo> queryPageList(EElevatorUserBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EElevatorUser> lqw = buildQueryWrapper(bo);
        Page<EElevatorUserVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的电梯及工作人员关联信息列表
     *
     * @param bo 查询条件
     * @return 电梯及工作人员关联信息列表
     */
    @Override
    public List<EElevatorUserVo> queryList(EElevatorUserBo bo) {
        LambdaQueryWrapper<EElevatorUser> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EElevatorUser> buildQueryWrapper(EElevatorUserBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EElevatorUser> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getElevatorNum()), EElevatorUser::getElevatorNum, bo.getElevatorNum());
        lqw.like(StringUtils.isNotBlank(bo.getElevatorName()), EElevatorUser::getElevatorName, bo.getElevatorName());
        lqw.eq(StringUtils.isNotBlank(bo.getElevatorAddress()), EElevatorUser::getElevatorAddress, bo.getElevatorAddress());
        lqw.like(StringUtils.isNotBlank(bo.getTenementName()), EElevatorUser::getTenementName, bo.getTenementName());
        lqw.eq(StringUtils.isNotBlank(bo.getElevatorId()), EElevatorUser::getElevatorId, bo.getElevatorId());
        lqw.eq(StringUtils.isNotBlank(bo.getUserId()), EElevatorUser::getUserId, bo.getUserId());
        lqw.eq(bo.getIsConcern() != null, EElevatorUser::getIsConcern, bo.getIsConcern());
        lqw.orderByDesc(EElevatorUser::getCreateTime);
        return lqw;
    }

    /**
     * 新增电梯及工作人员关联信息
     *
     * @param bo 电梯及工作人员关联信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EElevatorUserBo bo) {
        EElevatorUser add = MapstructUtils.convert(bo, EElevatorUser.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改电梯及工作人员关联信息
     *
     * @param bo 电梯及工作人员关联信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EElevatorUserBo bo) {
        EElevatorUser update = MapstructUtils.convert(bo, EElevatorUser.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EElevatorUser entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除电梯及工作人员关联信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    /**
     * 批量关注或取消关注电梯
     * @param bo
     * @return
     */
    @Override
    public Boolean concernOrCancel(EElevatorUserBo bo) {
        if (CollUtil.isEmpty(bo.getElevatorList())) {
            throw new ServiceException("电梯信息不能为空!");
        }
        if (StringUtils.isBlank(bo.getUserId())) {
            throw new ServiceException("工作人员信息不能为空!");
        }
        LambdaQueryWrapper<EElevatorUser> query = new LambdaQueryWrapper<>();
        query.eq(EElevatorUser::getUserId, bo.getUserId());
        query.in(EElevatorUser::getElevatorId, bo.getElevatorList());
        List<EElevatorUser> userList = baseMapper.selectList(query);
        if (CollUtil.isEmpty(userList)) {
            throw new ServiceException("暂未查询到该工作人员和电梯信息!");
        }
        for (EElevatorUser user : userList) {
            user.setIsConcern(bo.getIsConcern());
        }
        return baseMapper.updateBatchById(userList);
    }
}
